#define MAPWIDTH 21
#define MAPHEIGHT 16

// physical placement
#define HWIDTH  1.74
#define HHEIGHT 1.52
#define OFFSET  0.87

enum hexType { HxGrass=0, HxBoulder, HxTree, HxWater, HxBridge };

typedef struct __point_t point_t;

struct __point_t {
    int x,y;
};

typedef struct __mapNode_t mapNode_t;

struct __mapNode_t {
    point_t coords;
    mapNode_t* exits[6];
    int passable;

    // path variables
    int type;
    int G; // total cost so far
    int H; // huristic cost
    mapNode_t* pathParent;
    int onPath;
};


extern mapNode_t mapNodes[MAPWIDTH][MAPHEIGHT];
extern point_t evenDir[6];
extern point_t oddDir[6];

void buildMapLinks();
float distance(int ax, int ay, int bx, int by);
void findPath(mapNode_t* from, mapNode_t* to);
void resetPath();
bool inMap(Vector2 c);
